globals [ ticks ]
breed [ acquireds acquired]
breed [ acquirings acquiring ]
turtles-own [ skill ratio powerdistance penalty multiplier gapacquiring gappower partner org prob]
acquireds-own [engaged? ]
 

to setup
  ca
  set ticks 0
  
  set-default-shape acquireds "person"
  create-custom-acquireds initial-number-acquired-employees  
  [
    set color blue
    set size 1  ;; easier to see
    set label-color blue - 2
    set skill skill1 + random-float(1) * skillrange1
    set powerdistance powerdistance1 + random-float(1) * powerrange1
    setxy random-xcor random-ycor
    set engaged? false
  ]

  set-default-shape acquirings "person"
  create-custom-acquirings initial-number-acquiring-employees  
  [ set color red
    set size 1  ;; easier to see
    set skill skill2 + random-float(1) * skillrange2
    set powerdistance powerdistance2 + random-float(1) * powerrange2
    setxy random-xcor random-ycor
  ]

  ask turtles 
  [
  if architecture1 - architecture2 = 0
  [set penalty 1]
  if architecture1 - architecture2 = 1 or architecture1 - architecture2 = -1
  [set penalty 0.8]
  if architecture1 - architecture2 = 2 or architecture1 - architecture2 = -2
  [set penalty 0.6]
 ]
  
  do-plot
end

to go
  let number count turtles
  if number <= (initial-number-acquired-employees + initial-number-acquiring-employees) * objective [ stop ]
  ask turtles [
    move
    set skill skill - obsolescence
    death
    ]
  ask acquirings [
  interact]
  do-plot  ;; plot populations
  
  set ticks ticks + 1
end

to move  ;; turtle procedure
  rt random-float 50 - random-float 50
  fd 1
end

to interact
set org penalty 
     set partner one-of (acquireds-here             
                          with [not engaged?]) 
    if partner != nobody                             
   
    [ set engaged?-of partner true                 
      set gapacquiring skill - skill-of partner
      set gappower powerdistance - powerdistance-of partner
      ifelse skill > skill-of partner
      [set prob (powerdistance / (200)) * (gapacquiring / skill)
       set prob-of partner (powerdistance-of partner / (200)) * (gapacquiring / skill-of partner)]
      [set prob (powerdistance / (200)) * (-1 * gapacquiring / skill)
       set prob-of partner (powerdistance-of partner / (200)) * ( -1 * gapacquiring / skill-of partner)]
       
      let toss random-float(1)
     
      if toss < prob and toss < prob-of partner
      [learning]
      if toss >= prob and toss >= prob-of partner
      [conflict]
      if toss < prob and toss >= prob-of partner
      [learning-conflict]
      if toss >= prob and toss < prob-of partner
      [conflict-learning]

]
end

to learning-conflict  ;; turtle procedure
     
      set skill 0.8 * skill
      set skill-of partner skill-of partner + obsolescence
      set engaged?-of partner false
end

to conflict-learning  ;; turtle procedure
      set skill-of partner 0.8 * skill-of partner
      set skill skill + obsolescence
      set engaged?-of partner false
end
      


to learning  ;; turtle procedure
      
      ifelse gapacquiring > 0 
      [if skill-of partner < 400
      [set skill-of partner skill-of partner  +  0.8 * gapacquiring * org]
      if skill < 400
      [set skill skill +  0.2 * gapacquiring * org]
      set engaged?-of partner false]
      
      [if skill < 400
      [set skill skill -  0.8 * gapacquiring * org]
      if skill-of partner < 400
      [set skill-of partner skill-of partner - 0.2 * gapacquiring * org
      set engaged?-of partner false]]
end
 
 
 to conflict
      set skill-of partner 0.8 * skill-of partner
      set skill 0.8 * skill
      set engaged?-of partner false 
 end



 
to death  ;; turtle procedure
  if skill < 0 [ die ]
end

to do-plot
  set-current-plot "populations"
  set-current-plot-pen "acquired"
  plot count acquireds
  set-current-plot-pen "acquiring"
  plot count acquirings
  set-current-plot-pen "skill / 100"
  plot sum values-from turtles [skill] / count turtles 
end
@#$#@#$#@
GRAPHICS-WINDOW
367
26
1016
696
35
35
9.0
1
14
1
1
1
0
1
1
1
-35
35
-35
35

CC-WINDOW
5
710
1236
805
Command Center
0

SLIDER
10
88
252
121
initial-number-acquired-employees
initial-number-acquired-employees
0
250
250
1
1
NIL

SLIDER
11
122
252
155
initial-number-acquiring-employees
initial-number-acquiring-employees
0
250
100
1
1
NIL

BUTTON
7
27
76
60
setup
setup
NIL
1
T
OBSERVER
T
NIL

BUTTON
90
28
157
61
go
go
T
1
T
OBSERVER
T
NIL

PLOT
10
349
286
503
populations
time
pop.
0.0
100.0
0.0
100.0
true
true
PENS
"acquired" 1.0 0 -13345367 true
"acquiring" 1.0 0 -2674135 true
"skill / 100" 1.0 0 -16777216 true

MONITOR
93
241
186
290
Acquired
count acquireds
3
1

MONITOR
192
243
274
292
Acquiring
count acquirings
3
1

MONITOR
10
241
88
290
time-ticks
ticks
0
1

SLIDER
37
159
209
192
objective
objective
0
1
0.5
0.01
1
NIL

TEXTBOX
214
163
364
191
% of total employees after M&A\n

MONITOR
10
297
89
346
Skill 
sum values-from turtles [skill] \n
0
1

MONITOR
95
297
186
346
Avg Skill
sum values-from turtles [skill] / count turtles
3
1

SLIDER
855
38
1027
71
skill1
skill1
0
100
20
1
1
NIL

SLIDER
854
72
1026
105
Skillrange1
Skillrange1
0
100
20
1
1
NIL

SLIDER
848
304
1020
337
skill2
skill2
0
100
100
1
1
NIL

SLIDER
848
337
1020
370
skillrange2
skillrange2
0
100
100
1
1
NIL

SLIDER
855
173
1027
206
architecture1
architecture1
0
2
2
1
1
NIL

SLIDER
848
433
1020
466
architecture2
architecture2
0
2
2
1
1
NIL

TEXTBOX
1000
273
1150
301
Acquiring Firm

TEXTBOX
1012
10
1162
38
Acquired Firm

TEXTBOX
1061
43
1211
61
Average Knowledge Level

TEXTBOX
1059
80
1209
98
Knowledge Even Distribution

TEXTBOX
1062
165
1227
221
IS Architecture. 0 for Centralized, 1 for Decentralized, 2 for Distributed

TEXTBOX
1061
213
1225
255
Corporate Culture. 0 for Competitive, 1 for Collaborative

SLIDER
37
199
209
232
obsolescence
obsolescence
0
1
1.0
0.01
1
NIL

SLIDER
854
104
1026
137
powerdistance1
powerdistance1
1
100
100
1
1
NIL

SLIDER
854
138
1026
171
powerrange1
powerrange1
0
100
100
1
1
NIL

SLIDER
848
369
1020
402
powerdistance2
powerdistance2
1
100
50
1
1
NIL

SLIDER
848
401
1020
434
powerrange2
powerrange2
0
100
50
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
This model explores the stability of predator-prey ecosystems. (The construction of this model is described in two papers by Wilensky & Reisman referenced below.) Such systems are called unstable when they tend to result in extinction for one or more species involved.  In contrast, systems are stable when they tend to maintain themselves over time, despite fluctuations in population sizes. There are two main variations to this model.

In the first variation, wolves and sheep wonder randomly around the landscape, while the wolves look for sheep to prey on. Each step costs the wolves energy, and they must eat sheep in order to replenish their energy - when they run out of energy they die. To allow the population to continue, each wolf or sheep has a fixed probability of reproducing at each time step. This variation produces interesting population dynamics, but is ultimately unstable.

The second variation includes grass (green) in addition to wolves and sheep. The behavior of the wolves is identical to the first variation, however this time the sheep must eat grass in order to maintain their energy - when they run out of energy they die. Once grass is eaten it will only regrow after a fixed amount of time. This variation is more complex than the first, but it is generally stable.


HOW TO USE IT
-------------
1. Set the GRASS? switch to TRUE to include grass in the model, or to FALSE to only include wolves (red) and sheep (white).
2. Adjust the slider parameters (see below), or use the default settings.
3. Press the SETUP button.
4. Press the GO button to begin the simulation.
5. View the POPULATIONS plot to watch the populations fluctuate over time
6. View the count-sheep/count-wolves monitors to view current population sizes

Parameters:
INITIAL-NUMBER-SHEEP: The initial size of sheep population
INITIAL-NUMBER-WOLVES: The initial size of wolf population
SHEEP-GAIN-FROM-FOOD: The amount of energy sheep get for every grass patch eaten
WOLF-GAIN-FROM-FOOD: The amount of energy wolves get for every sheep eaten
SHEEP-REPRODUCE: The probability of a sheep reproducing at each time step
WOLF-REPRODUCE: The probability of a wolf reproducing at each time step
GRASS?: Whether or not to include grass in the model
GRASS-REGROWTH-TIME: How long it takes for grass to regrow once it is eaten
SHOW-ENERGY?: Whether or not to show the energy of each animal in the View

Notes:
- one unit of energy is deducted for every step a wolf takes
- when grass is included, one unit of energy is deducted for every step a sheep takes


THINGS TO NOTICE
----------------
When grass is not included, watch as the sheep and wolf populations fluctuate. Notice that increases and decreases in the sizes of each population are related. In what way are they related? What eventually happens?

Once grass is added, notice the green line added to the population plot representing fluctuations in the amount of grass. How do the sizes of the three populations appear to relate now? What is the explanation for this?

Why do you suppose that some variations of the model might be stable while others are not?


THINGS TO TRY
-------------
Try adjusting the parameters under various settings. How sensitive is the stability of the model to the particular parameters?

Can you find any parameters that generate a stable ecosystem that includes only wolves and sheep?

Try setting GRASS? to TRUE, but setting INITIAL-NUMBER-WOLVES to 0. This gives a stable ecosystem with only sheep and grass. Why might this be stable while the variation with only sheep and wolves is not?

Notice that under stable settings, the populations tend to fluctuate at a predictable pace. Can you find any parameters that will speed this up or slow it down?

Try changing the reproduction rules -- for example, what would happen if reproduction depended on energy rather than being determined by a fixed probability?


EXTENDING THE MODEL
-------------------
There are a number ways to alter the model so that it will be stable with only wolves and sheep (no grass). Some will require new elements to be coded in or existing behaviors to be changed. Can you develop such a version?


NETLOGO FEATURES
----------------
Note the use of breeds to model two different kinds of "turtles": wolves and sheep. Note the use of patches to model grass.

Note use of the ONE-OF agentset reporter to select a random sheep to be eaten by a wolf.


RELATED MODELS
---------------
Look at Rabbit Grass Weeds for another model of interacting populations with different rules.


CREDITS AND REFERENCES
----------------------
Wilensky, U. & Reisman, K. (1999). Connected Science: Learning Biology through Constructing and Testing Computational Theories -- an Embodied Modeling Approach. International Journal of Complex Systems, M. 234, pp. 1 - 12. (This model is a slightly extended version of the model described in the paper.)

Wilensky, U. & Reisman, K. (in press). Thinking like a Wolf, a Sheep or a Firefly: Learning Biology through Constructing and Testing Computational Theories -- an Embodied Modeling Approach. Cognition & Instruction.

To refer to this model in academic publications, please use:  Wilensky, U. (1998).  NetLogo Wolf Sheep Predation model.  http://ccl.northwestern.edu/netlogo/models/WolfSheepPredation.  Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

In other publications, please use:  Copyright 1998 Uri Wilensky.  All rights reserved.  See http://ccl.northwestern.edu/netlogo/models/WolfSheepPredation for terms of use.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -16777216 true false 166 225 195 285
Rectangle -16777216 true false 62 225 90 285
Rectangle -7500403 true true 30 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 180 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Rectangle -7500403 true true 195 106 285 150
Rectangle -7500403 true true 195 90 255 105
Polygon -7500403 true true 240 90 217 44 196 90
Polygon -16777216 true false 234 89 218 59 203 89
Rectangle -1 true false 240 93 252 105
Rectangle -16777216 true false 242 96 249 104
Rectangle -16777216 true false 241 125 285 139
Polygon -1 true false 285 125 277 138 269 125
Polygon -1 true false 269 140 262 125 256 140
Rectangle -7500403 true true 45 120 195 195
Rectangle -7500403 true true 45 114 185 120
Rectangle -7500403 true true 165 195 180 270
Rectangle -7500403 true true 60 195 75 270
Polygon -7500403 true true 45 105 15 30 15 75 45 150 60 120

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.1.5
@#$#@#$#@
setup
set grass? true
repeat 75 [ go ]
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="10" runMetricsEveryTick="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>sum values-from turtles [skill] / count turtles</metric>
    <metric>count acquireds</metric>
    <metric>count acquirings</metric>
  </experiment>
</experiments>
@#$#@#$#@
